<%
'****************************************************************************************
'**  Copyright Notice    
'**
'**  Web Wiz Guide - Web Wiz Mailing List
'**                                                              
'**  Copyright 2001-2005 Bruce Corkhill All Rights Reserved.                                
'**
'**  This program is free software; you can modify (at your own risk) any part of it 
'**  under the terms of the License that accompanies this software and use it both 
'**  privately and commercially.
'**
'**  All copyright notices must remain in tacked in the scripts and the 
'**  outputted HTML.
'**
'**  You may use parts of this program in your own private work, but you may NOT
'**  redistribute, repackage, or sell the whole or any part of this program even 
'**  if it is modified or reverse engineered in whole or in part without express 
'**  permission from the author.
'**
'**  You may not pass the whole or any part of this application off as your own work.
'**   
'**  All links to Web Wiz Guide and powered by logo's must remain unchanged and in place
'**  and must remain visible when the pages are viewed unless permission is first granted
'**  by the copyright holder.
'**
'**  This program is distributed in the hope that it will be useful,
'**  but WITHOUT ANY WARRANTY; without even the implied warranty of
'**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER 
'**  WARRANTIES WHETHER EXPRESSED OR IMPLIED.
'**
'**  You should have received a copy of the License along with this program; 
'**  if not, write to:- Web Wiz Guide, PO Box 4982, Bournemouth, BH8 8XP, United Kingdom.
'**    
'**
'**  No official support is available for this program but you may post support questions at: -
'**  http://www.webwizguide.info/forum
'**
'**  Support questions are NOT answered by e-mail ever!
'**
'**  For correspondence or non support questions contact: -
'**  info@webwizguide.info
'**
'**  or at: -
'**
'**  Web Wiz Guide, PO Box 4982, Bournemouth, BH8 8XP, United Kingdom
'**
'****************************************************************************************



'Declare global variables
Dim objCDOSYSMail	'Holds the CDOSYS mail object
Dim objCDOMail		'Holds the CDONTS mail object
Dim objJMail		'Holds the Jmail object
Dim objAspEmail		'Holds the Persits AspEmail email object
Dim objAspMail		'Holds the Server Objects AspMail email object


'****************************************
'**         Create mail function       **
'****************************************

'Function to create mail object
Public Function createMailObject(ByVal strMailComponent)

	

	'Now the code selects the email component to use set from your configuration in the admin area
	Select Case strMailComponent
	
		'CDOSYS mail component
		Case "CDOSYS"
		
			'Dimension variables
			Dim objCDOSYSCon
			Dim intSendUsing
			
			'Calculate the port we are sendusing (1=localhost 2=network)
			If LCase(strMailServer) = "localhost" OR strMailServer = "http://127.0.0.1" OR strMailServer = "127.0.0.1" Then
				intSendUsing = 1
			Else
				intSendUsing = 2
			End If
			
			'Create the e-mail server object
			Set objCDOSYSMail = Server.CreateObject("CDO.Message")
		    	Set objCDOSYSCon = Server.CreateObject ("CDO.Configuration")
		    	
		    	'Set and update fields properties
		    	With objCDOSYSCon
		    	 	
		    		'Use SMTP Server authentication if required
		    		If strMailServerUser <> "" AND strMailServerPass <> "" Then 
			    		' Specify the authentication mechanism to basic (clear-text) authentication cdoBasic = 1
			        	.Fields("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
			        	
			        	'SMTP Server username
			        	.Fields("http://schemas.microsoft.com/cdo/configuration/sendusername") = strMailServerUser
			        	
			        	'SMTP Server password
			        	.Fields("http://schemas.microsoft.com/cdo/configuration/sendpassword") = strMailServerPass
			        End If
		        	
		        	'Out going SMTP server
		        	.Fields("http://schemas.microsoft.com/cdo/configuration/smtpserver") = strMailServer
		        	
		        	'SMTP port
		        	.Fields("http://schemas.microsoft.com/cdo/configuration/smtpserverport")  = 25
		        	
		        	'CDO Port (1=localhost 2=network)
		        	.Fields("http://schemas.microsoft.com/cdo/configuration/sendusing") = intSendUsing
		        	
		        	'Set CDO pickup directory if using localhost (CDO Port 1)
		        	If intSendUsing = 1 Then
		        		'CDO pickup directory (used for localhost service)
		        		.Fields("http://schemas.microsoft.com/cdo/configuration/smtpserverpickupdirectory") = "c:\inetpub\mailroot\pickup" 
		        	End If
		        	
		        	'Timeout
		        	.Fields("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = 60
	        		
	        		'Update CDO configuration
	        		.Fields.Update 
	        	End With
			
			'Update the CDOSYS Configuration
			Set objCDOSYSMail.Configuration = objCDOSYSCon

		'CDONTS mail component
		Case "CDONTS"
		
			'With CDONTS the object has to be created for each email 
		
		'JMail component
		Case "Jmail"
		
			'Create the e-mail server object
			Set objJMail = Server.CreateObject("JMail.SMTPMail")
			
		'JMail 4 component
		Case "Jmail4"
		
			'Create the e-mail server object
			Set objJMail = Server.CreateObject("Jmail.Message")
		
		'AspEmail component
		Case "AspEmail"
		
			'Create the e-mail server object
			Set objAspEmail = Server.CreateObject("Persits.MailSender")
		
		'AspMail component
		Case "AspMail"
		
			'Create the e-mail server object
		   	Set objAspMail = Server.CreateObject("SMTPsvg.Mailer")

	End Select
End Function



'****************************************
'**         Drop mail function         **
'****************************************

'Function to drop mail object
Public Function dropMailObject(ByVal strMailComponent)

	'Select which email component to use
	Select Case strMailComponent
	
		'CDOSYS mail component
		Case "CDOSYS"
		  	Set objCDOSYSMail = Nothing
		
		'CDONTS mail component
		Case "CDONTS"
			'With CDONTS the object has to be created and dropped for each email 
			
		'JMail component
		Case "Jmail"
			Set objJMail = Nothing
			
		'JMail 4 component
		Case "Jmail4"
			Set objJMail = Nothing
		
		'AspEmail component
		Case "AspEmail"
			Set objAspEmail = Nothing
		
		'AspMail component
		Case "AspMail"
			Set objAspMail = Nothing
	End Select
End Function



'****************************************
'**         Send mail function         **
'****************************************

'Function to send an e-mail
Public Function SendMail(ByVal strToName, ByVal strEmailAddress, ByVal strMailComponent, ByVal strMailFormat)

	Dim strAppendToEmail

	'Select which email component to use
	Select Case strMailComponent
	
		'CDOSYS mail component
		Case "CDOSYS"	
		
			With objCDOSYSMail	
				'Who the e-mail is from
				.From = """" & strWebsiteName & """ <" & strWebsiteEmailAddress & ">"""
							
				'Who the e-mail is sent to
				.To = """" & strToName & """ <" & strEmailAddress & ">"""
									
				'The subject of the e-mail
				.Subject = strSubject
							
				'Set the e-mail body format (HTMLBody=HTML TextBody=Plain)
				If strMailFormat = "HTML" Then
				 	.HTMLBody = strEmailBody & strAppendToEmail
				Else
					.TextBody = strEmailBody & strAppendToEmail
				End If
							
				'Send the e-mail
				If NOT strMailServer = "" Then .Send
			End with				
		
		'CDONTS mail component
		Case "CDONTS"
		
			'Create the e-mail server object (this has to be set with each email for CDONTS)
			Set objCDOMail = Server.CreateObject("CDONTS.NewMail")
		
			With objCDOMail
				'Who the e-mail is from
				.From = """" & strWebsiteName & """ <" & strWebsiteEmailAddress & ">"""
							
				'Who the e-mail is sent to
				.To = """" & strToName & """ <" & strEmailAddress & ">"""
									
				'The subject of the e-mail
				.Subject = strSubject
							
				'The main body of the e-amil
				.Body = strEmailBody & strAppendToEmail
							
				'Set the e-mail body format (0=HTML 1=Text)
				If strMailFormat = "HTML" Then
					.BodyFormat = 0
				Else
					.BodyFormat = 1
				End If
				
				'Set the mail format (0=MIME 1=Text)
				.MailFormat = 0
							
				'Importance of the e-mail (0=Low, 1=Normal, 2=High)
				.Importance = 1 
							
				'Send the e-mail
				.Send	
			End With
			
			'Release the object (this has to be done with each email for CDONTS)
			Set objCDOMail = Nothing
					
		
		'JMail component
		Case "Jmail"
	
			With objJMail
				'Out going SMTP mail server address
				.ServerAddress = strMailServer
				
				'Clear the Recipient List
				.ClearRecipients()
			
				'Who the e-mail is from
				.Sender = strWebsiteEmailAddress
				.SenderName = strWebsiteName
						
				'Who the e-mail is sent to
				.AddRecipient strEmailAddress
										
				'The subject of the e-mail
				.Subject = strSubject
				
				'Set the e-mail body format (BodyHTML=HTML Body=Text)
				If strMailFormat = "HTML" Then
					.ContentType = "text/html"
					.HTMLBody = strEmailBody & strAppendToEmail
				Else
					.Body = strEmailBody & strAppendToEmail
				End If
							
				'Importance of the e-mail
				.Priority = 3 
							
				'Send the e-mail
				If NOT strMailServer = "" Then .Execute	
				
				'Clear the Recipient List
				.ClearRecipients()
			End With
			
		'JMail 4+ component
		Case "Jmail4"
	
			With objJMail
				
				'Send SMTP Server authentication data
    				If NOT strMailServerUser = "" Then .MailServerUserName = strMailServerUser
    				If NOT strMailServerPass = "" Then .MailServerPassword = strMailServerPass
    				
    				'Clear the Recipient List
				.Recipients.Clear
				.ClearRecipients
    				
				'Who the e-mail is from
				.From = strWebsiteEmailAddress
				.FromName = strWebsiteName
						
				'Who the e-mail is sent to
				.AddRecipient strEmailAddress, strToName
										
				'The subject of the e-mail
				.Subject = strSubject
				
				'Set the e-mail body format (BodyHTML=HTML Body=Text)
				If strMailFormat = "HTML" Then
					.ContentType = "text/html"
					.HTMLBody = strEmailBody & strAppendToEmail
				Else
					.Body = strEmailBody & strAppendToEmail
				End If
							
				'Importance of the e-mail
				.Priority = 3 
							
				'Send the e-mail
				If NOT strMailServer = "" Then .Send(strMailServer)
				
				'Clear the Recipient List
				.Recipients.Clear
				.ClearRecipients
			End With
	
	
		'AspEmail component
		Case "AspEmail"
	
			With objAspEmail
				'Out going SMTP mail server address
				.Host = strMailServer
				
				'SMTP server username and password
				.Username = strMailServerUser
				.Password = strMailServerPass
					
				'Who the e-mail is from
				.From = strWebsiteEmailAddress
				.FromName = strWebsiteName
					
				'Who the e-mail is sent to
				.AddAddress strEmailAddress, strToName
													
				'The subject of the e-mail
				.Subject = strSubject
				
				'Set the e-mail body format (BodyHTML=HTML Body=Text)
				If strMailFormat = "HTML" Then
					.IsHTML = True
				End If
				
				'The main body of the e-mail
				.Body = strEmailBody & strAppendToEmail
				
				'Set the queuing agent to queue messages to the SMTP server
				.Queue = True
										
				'Send the e-mail
				If NOT strMailServer = "" Then .Send
				
				'Reset the object
				.ResetAll	
			End With		
						

		'AspMail component
		Case "AspMail"

		   	With objAspMail
			   	'Out going SMTP mail server address
			   	.RemoteHost = strMailServer
			    
			   	'Who the e-mail is from
			   	.FromAddress = strWebsiteEmailAddress
			   	.FromName = strWebsiteName
			    
			   	'Who the e-mail is sent to
			   	.AddRecipient strToName, strEmailAddress
			            
			   	'The subject of the e-mail
			   	.Subject = strSubject
			   
			   	'Set the e-mail body format (BodyHTML=HTML Body=Text)
			   	If strMailFormat = "HTML" Then
			    		.ContentType = "text/HTML"
			   	End If
			   
			   	'The main body of the e-mail
			   	.BodyText = strEmailBody & strAppendToEmail
			         
			   	'Send the e-mail
			   	If NOT strMailServer = "" Then .SendMail 
			   	
			   	'Clear the Recipient List
			   	.ClearRecipients
			   	
			   	'Clear the email body text
			   	.ClearBodyText
			End With
	End Select	
End Function




'****************************************
'**      Create mail body function     **
'****************************************

'***** START WARNING - REMOVAL OR MODIFICATION OF THIS CODE WILL VIOLATE THE LICENSE AGREEMENT ******
'Function create the remove appended part of the email
'- This needs to stay in place for the software to stay legal in most countries
Private Function mailBody(ByVal strMailFormat, ByVal strEmail, ByVal blnLCode)

	Dim strAppendToEmail

	'If the e-mail is in HTML format then change the format of the e-mail
	If strMailFormat = "HTML" Then
		'***** START WARNING - REMOVAL OR MODIFICATION OF THIS CODE WILL VIOLATE THE LICENSE AGREEMENT ******
		'Write a remove from mailing list message to add to the end of the e-mail in HTML Format
		strAppendToEmail = "<br /><br /><hr />" & _
		strTxtToUnsubscribeOrChangePref & ":-<br />" & _
		"<a href=""" & strWebsiteAddress & "default.asp?email=" & strEmail & """>" & strWebsiteAddress & "default.asp?email=" & Server.URLEncode(strEmail) & "</a>"
		If blnLCode = True Then
			strAppendToEmail = strAppendToEmail & "<br /><br />Free Newsletter software provided by Web Wiz Mailing List version " & strVersion & " - http://www.webwizmailinglist.com" & _
			"<br /><br />The Web Wiz Mailing List software is provided free by Web Wiz Guide in a downloadable zip file to be installed on the email senders own computer systems or the systems of their web host. Web Wiz Guide has no control over how the software is used or the contents of any email sent by said software. Spam email is taken a very dim view of and measures have been built into the software to prevent and minimise the use of spammers abusing the software. If you feel this email is spam please take this up with the sender of this email and/or the owners of the mail server(s) they use to send this email."
		End If 
		'***** END WARNING - REMOVAL OR MODIFICATION OF THIS CODE WILL VIOLATE THE LICENSE AGREEMENT ******
		strAppendToEmail = strAppendToEmail & "</body></html>"
			
  	'Else the email is text based
  	Else		
		'***** START WARNING - REMOVAL OR MODIFICATION OF THIS CODE WILL VIOLATE THE LICENSE AGREEMENT ******'Write a remove from mailing list message to add to the end of the e-mail in Plain Text Format
		strAppendToEmail = vbCrLf & vbCrLf & "__________________________________________________________" & _
		vbCrLf & strTxtToUnsubscribeOrChangePref & ":-" & _
		vbCrLf & strWebsiteAddress & "default.asp?email=" & Server.URLEncode(strEmail)
		If blnLCode = True Then
			strAppendToEmail = strAppendToEmail & vbCrLf & vbCrLf & "Free Newsletter software provided by Web Wiz Mailing List version " & strVersion & " - http://www.webwizmailinglist.com" & _
			vbCrLf & vbCrLf & "The Web Wiz Mailing List software is provided free by Web Wiz Guide in a downloadable zip file to be installed on the email senders own computer systems or the systems of their web host. Web Wiz Guide has no control over how the software is used or the contents of any email sent by said software. Spam email is taken a very dim view of and measures have been built into the software to prevent and minimise the use of spammers abusing the software. If you feel this email is spam please take this up with the sender of this email and/or the owners of the mail server(s) they use to send this email."
		End If 
		
		'***** END WARNING - REMOVAL OR MODIFICATION OF THIS CODE WILL VIOLATE THE LICENSE AGREEMENT ******
	End If
	
	'Return function
	mailBody = strAppendToEmail
End Function
'***** END WARNING - REMOVAL OR MODIFICATION OF THIS CODE WILL VIOLATE THE LICENSE AGREEMENT ******
%>